addonName, ns = ...
ns.mult = 768/string.match(GetCVar("gxResolution"), "%d+x(%d+)")
SuperClassic = CreateFrame("frame", "SuperClassic", UIParent)
SuperClassic.cc = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[select(2, UnitClass("player"))] or RAID_CLASS_COLORS[select(2, UnitClass("player"))] or  { r=.5, g=.5, b=.5 }

local settingsChanged = false
INTERFACE_ACTION_BLOCKED = ""


MovePlayerFrame = function() end

DefaultSettings = {
	firstStart = true,
	
	["Main"] = {
		["UIScale"] = false,
		["Font"] = "Interface\\Addons\\"..addonName.."\\media\\font.ttf",
		["ClassColored"] = false,
	},
}


local handler = CreateFrame("Button", "MyCastRandHandler", UIParent, "SecureHandlerClickTemplate")
local button = CreateFrame("Button", "mrb", handler, "SecureActionButtonTemplate")
button:SetAttribute("type", "spell")
handler:Execute( [[ castList = newtable("Воющий ветер", "Некротический Удар", "Ледяной удар") listSize = #castList secureButton = self:GetChildren() ]] )
SecureHandlerWrapScript(button, "OnClick", handler, [[ secureButton:SetAttribute("spell", castList[random(listSize)]) ]] )

FDROTON = false
fdrotonf = CreateFrame("frame")
FDROT = function()
	if not FDROTON then
		FDROTON = true
		print("|cff00dd00rot on|c")
		fdrotonf:SetScript("OnUpdate", function(self, e)
			local playerPower=UnitPower("player")
			if UnitBuff("player", "Ясность мысли") then
				playerPower = 100
			end
			
			local comboPoints=GetComboPoints("player")
			local shredPower=({GetSpellInfo("Полоснуть")})[4]
			local manglePower=({GetSpellInfo("Увечье(Облик кошки)")})[4]
			local rakePower=({GetSpellInfo("Глубокая рана")})[4]
			local hasTrauma=0
			local i=1 
			local ripTime=0
			local rakeTime=0
			local mangleTime=0
			
			if UnitHealth("player")/UnitHealthMax("player")<0.40 and GetSpellCooldown("Дубовая кожа")==0 then 
				CastSpellByName("Дубовая кожа") 
			end

			while(i<=40)do 
				local aura={UnitDebuff("target",i)} 
				if (aura and aura[1] and (aura[1]:find("Увечье") or aura[1]:find("Травма"))) then 
					hasTrauma=1
					break 
				else 
					i=i+1 
				end 
			end

			for i=1,40 do 
				aura={UnitDebuff("target",i)} 
				if aura[8]=="player" then 
					d=aura[7]-GetTime(); 
					if aura[1]=="Разорвать" then 
						ripTime=d 
					elseif aura[1]=="Глубокая рана" then 
						rakeTime=d 
					elseif aura[1]:find("Увечье") then 
						mangleTime=d 
					end 
				end 
			end

			if GetSpellCooldown("Тигриное неистовство")==0 and not UnitBuff("player","Берсерк") and playerPower<30 then 
				if GetComboPoints("player")>4 then 
					if ripTime==0 or 60+playerPower+ripTime*10<100 then 
						CastSpellByName("Тигриное неистовство") 
					end 
				else 
					CastSpellByName("Тигриное неистовство") 
				end 
			end

			if GetComboPoints("player")>4 then 
				if ripTime<=2 then 
					if playerPower>({GetSpellInfo("Разорвать")})[4] then 
						CastSpellByName("Разорвать") 
					end 
				--elseif GetSpellCooldown("Свирепый укус")==0 then
					--if playerPower>({GetSpellInfo("Свирепый укус")})[4] then 
						--CastSpellByName("Свирепый укус") 
					--end 
				else 
					d=ripTime*10-5; 
					if d+playerPower>=100 then 
						if playerPower>=manglePower and hasTrauma==0 and mangleTime<3 
							then CastSpellByName("Увечье(Облик кошки)") 
						elseif playerPower>=rakePower and rakeTime<3 then 
							CastSpellByName("Глубокая рана") 
						elseif playerPower>=shredPower then 
							if IsShiftKeyDown() then
								CastSpellByName("Увечье(Облик кошки)") 
							else
								CastSpellByName("Полоснуть") 
							end
						end 
					end 
				end 
			end

			if not UnitDebuff("target","Волшебный огонь") and not UnitDebuff("target","Волшебный огонь (Облик зверя)") and GetSpellCooldown("Волшебный огонь (Облик зверя)")==0 then 
				CastSpellByName("Волшебный огонь (Облик зверя)") 
			end

			if hasTrauma==0 and mangleTime<=rakeTime and not ((comboPoints>0 and playerPower<25) or comboPoints>4) then 
				if mangleTime<3 and playerPower>=manglePower then 
					CastSpellByName("Увечье(Облик кошки)") 
				end 
			end

			if not ((comboPoints>0 and playerPower<25) or comboPoints>4) and rakeTime<mangleTime then 
				if rakeTime<2.5 and playerPower>=rakePower then 
					CastSpellByName("Глубокая рана") 
				end 
			end

			if not ((comboPoints>0 and playerPower<25) or comboPoints>4) then 
				if playerPower > shredPower then 
					if IsShiftKeyDown() then
						CastSpellByName("Увечье(Облик кошки)") 
					else
						CastSpellByName("Полоснуть") 
					end
				end 
			end

			StaticPopup_Hide("MACRO_ACTION_FORBIDDEN");
		end)
	else
		FDROTON = false
		fdrotonf:SetScript("OnUpdate", nil)
		print("|cffff0000rot off|c")
	end
end

SECOND_NUMBER_CAP = SECOND_NUMBER_CAP:lower()
FIRST_NUMBER_CAP = FIRST_NUMBER_CAP:lower()

function fixvalue(val)
   if(val >= 1e6) then
	  return ('%.2f'..SECOND_NUMBER_CAP):format(val / 1e6):gsub('%.?0+(['..FIRST_NUMBER_CAP..SECOND_NUMBER_CAP..'])$', '%1')
   elseif(val >= 1e4) then
	  return ('%.1f'..FIRST_NUMBER_CAP):format(val / 1e3):gsub('%.?0+(['..FIRST_NUMBER_CAP..SECOND_NUMBER_CAP..'])$', '%1')
   else
	  return val
   end
end

rgb2str = function(col) local r, g, b = unpack(col) return format("|cff%02x%02x%02x", r*255, g*255, b*255) end
rgb2str = function(r, g, b) return format("|cff%02x%02x%02x", r*255, g*255, b*255) end

gradient_s = function(val, bad, good)
    gradient = function(val, bad, good)
        local percent, r, g
        if (good > bad) then 
            percent = val/(good-bad)
        else 
            percent = 1-val/(bad-good) 
        end
        if (percent > 1) then percent = 1 end
        if (percent < 0) then percent = 0 end
        if(percent < 0.5) then r, g = 1, 2*percent   else  r, g = (1-percent)*2, 1 end
        return r, g, 0
    end
    return rgb2str(gradient(val, bad, good))
end 


FlashObject = function(self, duration, stop)
	if not self.anim then
		self.anim = self:CreateAnimationGroup("Scale")
		self.anim.fadein = self.anim:CreateAnimation("SCALE", "FadeIn")
		self.anim.fadein:SetScale(1,1)
		self.anim.fadein:SetOrder(1)

		self.anim.fadeout = self.anim:CreateAnimation("SCALE", "FadeOut")
		self.anim.fadeout:SetScale(0.7, 0.7)
		self.anim.fadeout:SetOrder(1)
		self.anim:SetLooping("BOUNCE")
	end

	self.anim.fadein:SetDuration(duration)
	self.anim.fadeout:SetDuration(duration)
	self.anim:Play()
	if self.anim and stop then
		self.anim:Finish()
	end
end

local function setupVars()
	SetCVar("showTargetOfTarget", 1)
	SetCVar("buffDurations", 1)
	SetCVar("consolidateBuffs", 0)
	SetCVar("autoLootDefault", 1)
	SetCVar("lootUnderMouse", 1)
	SetCVar("autoSelfCast", 1)
	SetCVar("mapQuestDifficulty", 1)
	SetCVar("scriptErrors", 1)
	SetCVar("nameplateShowFriends", 0)
	SetCVar("nameplateShowFriendlyPets", 0)
	SetCVar("nameplateShowFriendlyGuardians", 0)
	SetCVar("nameplateShowFriendlyTotems", 0)
	SetCVar("nameplateShowEnemies", 1)
	SetCVar("nameplateShowEnemyPets", 0)
	SetCVar("nameplateShowEnemyGuardians", 0)
	SetCVar("nameplateShowEnemyTotems", 1)
	SetCVar("ShowClassColorInNameplate", 1)
	
	SetCVar("screenshotQuality", 10)
	SetCVar("cameraDistanceMax", 50)
	SetCVar("cameraDistanceMaxFactor", 3.4)
	SetCVar("chatMouseScroll", 1)
	SetCVar("showTimestamps", "none")
	SetCVar("chatStyle", "classic")
	SetCVar("WholeChatWindowClickable", 0)
	SetCVar("ConversationMode", "inline")
	SetCVar("CombatDamage", 1)
	SetCVar("CombatHealing", 1)
	SetCVar("showTutorials", 0)
	SetCVar("showNewbieTips", 0)
	SetCVar("Maxfps", 120)
	SetCVar("autoDismountFlying", 1)
	SetCVar("autoQuestWatch", 1)
	SetCVar("autoQuestProgress", 1)
	SetCVar("showLootSpam", 1)
	SetCVar("guildMemberNotify", 1)
	SetCVar("chatBubblesParty", 1)
	SetCVar("chatBubbles", 1)
	SetCVar("UnitNameOwn", 1)
	SetCVar("UnitNameNPC", 1)
	SetCVar("UnitNameNonCombatCreatureName", 1)
	SetCVar("UnitNamePlayerGuild", 1)
	SetCVar("UnitNamePlayerPVPTitle", 1)
	SetCVar("UnitNameFriendlyPlayerName", 1)
	SetCVar("UnitNameFriendlyPetName", 1)
	SetCVar("UnitNameFriendlyGuardianName", 1)
	SetCVar("UnitNameFriendlyTotemName", 1)
	SetCVar("UnitNameEnemyPlayerName", 1)
	SetCVar("UnitNameEnemyPetName", 1)
	SetCVar("UnitNameEnemyGuardianName", 1)
	SetCVar("UnitNameEnemyTotemName", 1)
	SetCVar("removeChatDelay", 1)
	SetCVar("showVKeyCastbar", 1)
	SetCVar("colorblindMode", 0)
	
	SetCVar("predictedHealth", 1)
	SetCVar("predictedPower", 1)
	SetCVar("violenceLevel", 5)
end

function PaintTextures()
	local cl = (SCDB and SCDB["Main"] and SCDB["Main"].ClassColored == true)
	local r1, g1, b1, a1 = 1,1,1,1 -- top color
	local r2, g2, b2, a2 = cl and SuperClassic.cc.r or .4, cl and SuperClassic.cc.g or .4, cl and SuperClassic.cc.b or .4, 1 -- bottom color

      for _, obj in ipairs({Minimap:GetChildren()}) do
            if (obj and (obj:GetObjectType() == "Frame" or obj:GetObjectType() == "Button")) then
                  for _, tex in ipairs({obj:GetRegions()}) do
                        if (tex and tex:GetObjectType() == "Texture") then
                              if tex:GetTexture() == "Interface\\Minimap\\MiniMap-TrackingBorder" then
								tex:SetVertexColor(1, 1, 1)
								tex:SetDesaturated(1)
								tex:SetVertexColor(r2, g2, b2)
                              end
                        end
                  end
            end
      end
	
	for i,v in pairs({
		-- Action bars
		MainMenuMaxLevelBar0,
		MainMenuMaxLevelBar1,
		MainMenuBarTexture0,
		MainMenuBarTexture1,
		MainMenuBarTexture2,
		MainMenuBarTexture3,
		MainMenuXPBarTextureRightCap,
		MainMenuXPBarTextureMid,
		MainMenuXPBarTextureLeftCap,
		ActionBarUpButton:GetRegions(),
		ActionBarDownButton:GetRegions(),
		BonusActionBarFrame:GetRegions(),
		select(2, BonusActionBarFrame:GetRegions()),
		
		-- Unit frames
		PlayerFrameTexture,
		TargetFrameTextureFrameTexture,
		FocusFrameTextureFrameTexture,
		TargetFrameToTTextureFrameTexture,
		FocusFrameToTTextureFrameTexture,
		PetFrameTexture,
		
		-- Minimap
		MinimapBackdrop,
		MinimapBorder,
		MiniMapMailBorder,
		MiniMapTrackingButtonBorder,
		MinimapBorderTop,
		MinimapZoneTextButton,
		MiniMapWorldMapButton,
		MiniMapWorldMapButton,
		MiniMapWorldIcon,
		MinimapZoomIn:GetRegions(),
		MinimapZoomOut:GetRegions(),
		TimeManagerClockButton:GetRegions(),
		MiniMapWorldMapButton:GetRegions(),
		select(6, GameTimeFrame:GetRegions()),
		
		-- Exp bubble dividers
		MainMenuXPBarDiv1,
		MainMenuXPBarDiv2,
		MainMenuXPBarDiv3,
		MainMenuXPBarDiv4,
		MainMenuXPBarDiv5,
		MainMenuXPBarDiv6,
		MainMenuXPBarDiv7,
		MainMenuXPBarDiv8,
		MainMenuXPBarDiv9,
		MainMenuXPBarDiv10,
		MainMenuXPBarDiv11,
		MainMenuXPBarDiv12,
		MainMenuXPBarDiv13,
		MainMenuXPBarDiv14,
		MainMenuXPBarDiv15,
		MainMenuXPBarDiv16,
		MainMenuXPBarDiv17,
		MainMenuXPBarDiv18,
		MainMenuXPBarDiv19,
		
		-- Chat frame buttons
		select(2, FriendsMicroButton:GetRegions()),
		ChatFrameMenuButton:GetRegions(),
		ChatFrame1ButtonFrameUpButton:GetRegions(),
		ChatFrame1ButtonFrameDownButton:GetRegions(),
		select(2, ChatFrame1ButtonFrameBottomButton:GetRegions()),
		ChatFrame2ButtonFrameUpButton:GetRegions(),
		ChatFrame2ButtonFrameDownButton:GetRegions(),
		select(2, ChatFrame2ButtonFrameBottomButton:GetRegions()),
		
		-- Chat edit box
		select(6, ChatFrame1EditBox:GetRegions()),
		select(7, ChatFrame1EditBox:GetRegions()),
		select(8, ChatFrame1EditBox:GetRegions()),
		select(5, ChatFrame1EditBox:GetRegions()),
		
		-- Micro menu buttons
		select(2, SpellbookMicroButton:GetRegions()),
		select(3, CharacterMicroButton:GetRegions()),
		select(2, TalentMicroButton:GetRegions()),
		select(2, AchievementMicroButton:GetRegions()),
		select(2, QuestLogMicroButton:GetRegions()),
		select(2, GuildMicroButton:GetRegions()),
		select(3, PVPMicroButton:GetRegions()),
		select(2, LFDMicroButton:GetRegions()),
		select(4, MainMenuMicroButton:GetRegions()),
		select(2, HelpMicroButton:GetRegions()),
		
		-- Other
		select(2, CastingBarFrame:GetRegions()),
		select(2, MirrorTimer1:GetRegions()),
		MainMenuBarLeftEndCap,
		MainMenuBarRightEndCap,
	}) do
		if v:GetObjectType() == "Texture" then
			v:SetVertexColor(1, 1, 1)
			v:SetDesaturated(1)
			v:SetVertexColor(r2, g2, b2)
		end
	end
	
	-- Desaturation fix for elite target texture (thanks SDPhantom!)
	hooksecurefunc("TargetFrame_CheckClassification", function(self)
		self.borderTexture:SetDesaturated(1)
	end)
	
	-- Game tooltip
	TOOLTIP_DEFAULT_COLOR = { r = r1 * .6, g = g1 * .6, b = b1 * .6 }
	TOOLTIP_DEFAULT_BACKGROUND_COLOR = { r = r2 * .1, g = g2 * .1, b = b2 * .1}
	
	if cl then
		MinimapBackdrop:SetBackdropBorderColor(SuperClassic.cc.r*.5, SuperClassic.cc.g*.5, SuperClassic.cc.b*.5)
	else
		MinimapBackdrop:SetBackdropBorderColor(.4,.4,.4)
	end
end

local ef = CreateFrame("frame")
ef:RegisterEvent("ADDON_LOADED")
ef:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		PaintTextures()
	end
end)
PaintTextures()

local function SetValue(group, option, value, parent)
	if parent then
		SCDB[parent][group][option] = value
		settingsChanged = true
	else
		SCDB[group][option] = value
		settingsChanged = true
	end
end

local NewButton = function(text,parent)
	local result = CreateFrame("Button", "btn_"..parent:GetName(), parent, "UIPanelButtonTemplate")
	result:SetText(text)
	return result
end

local NewLabel = function(text,parent, justify)
	local label = parent:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	label:SetText(text)
	label:SetJustifyH(justify or "LEFT")
	return label
end

parseOptions = function(mainframe, group, opt, parent)
	if not opt then return end
	
	local scrollf = CreateFrame("ScrollFrame", "interface_scrollf"..group, mainframe, "UIPanelScrollFrameTemplate")
	local frame = CreateFrame("frame", group, scrollf)
	scrollf:SetScrollChild(frame)
	scrollf:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 20, -40)
	scrollf:SetPoint("BOTTOMRIGHT", mainframe, "BOTTOMRIGHT", -40, 45)
	frame:SetPoint("TOPLEFT")
   frame:SetWidth(130)
   frame:SetHeight(130)
	
	local offset=5
	local tmparr = {}
	for option, value in pairs(opt) do
		table.insert(tmparr, { ["option"] = option, ["value"] = value })
	end
	table.sort(tmparr, function(a,b) return tostring(a.option) < tostring(b.option) end)
	
	for index, array in ipairs(tmparr) do
		local option, value = array.option, array.value
		if type(value) == "boolean" then
			local button = CreateFrame("CheckButton", "config_"..option, frame, "InterfaceOptionsCheckButtonTemplate")
			_G["config_"..option.."Text"]:SetText(option)
			button:SetChecked(value)
			button:SetScript("OnClick", function(self) SetValue(group,option,(self:GetChecked() and true or false), parent); _G[self:GetName().."Text"]:SetTextColor(.1,1,.1); end)
			button:SetPoint("TOPLEFT", 15, -(offset))
			offset = offset+25
		elseif type(value) == "number" or type(value) == "string" and not value:find("function") then
			local label = NewLabel(option, frame)
			label:SetPoint("TOPLEFT", 15, -(offset))
			
			local editbox = CreateFrame("EditBox", "editbox_"..option, frame)
			editbox:SetAutoFocus(false)
			editbox:SetMultiLine(false)
			editbox:SetWidth(220)
			editbox:SetHeight(20)
			editbox:SetMaxLetters(255)
			editbox:SetTextInsets(3,0,0,0)
			editbox:SetJustifyH("LEFT")
			editbox:SetBackdrop({
				bgFile = "Interface\\Buttons\\WHITE8x8", 
				tiled = false,
			})
			editbox:SetBackdropColor(0,0,0,0.5)
			editbox:SetBackdropBorderColor(0,0,0,1)
			editbox:SetFontObject("GameFontHighlight")
			editbox:SetPoint("TOPLEFT", 15, -(offset+20))
			editbox:SetText(value)
			
			local save = CreateFrame("button", option.."SaveButton", frame)
			save:SetNormalTexture("Interface\\Buttons\\UI-Panel-SmallerButton-Up")
			save:SetPushedTexture("Interface\\Buttons\\UI-Panel-SmallerButton-Down")
			save:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
			save:SetWidth(32)
			save:SetHeight(32)
			save:SetPoint("LEFT", editbox, "RIGHT", 5, 0)
			save:SetScript("OnClick", function(self) 
				editbox:ClearFocus()
				editbox:SetBackdropBorderColor(.2,1,.2)
				if type(value) == "number" then
					SetValue(group,option,tonumber(editbox:GetText()), parent)
				else
					SetValue(group,option,tostring(editbox:GetText()), parent)
				end
			end)
			
			offset = offset+45
		elseif type(value) == "table" then
			if value.vtype ~= nil then
				
			else
				if #value <= 4 and type(value[1]) == "number" and value[1] <= 1 and value[2] <= 1 and value[3] <= 1 then
					local label = NewLabel(option, frame)
			
					local but = CreateFrame("Button", "btnt_"..option, frame)
					but:SetWidth(20)
					but:SetHeight(20)
					but:SetPoint("TOPLEFT", 15, -(offset))
					
					label:SetPoint("LEFT", but, "RIGHT", 5, 0)
					
					but.tex = but:CreateTexture(nil)
					but.tex:SetTexture(value[1], value[2], value[3], value[4] or 1)
					but.tex:SetPoint("TOPLEFT", 2, -2)
					but.tex:SetPoint("BOTTOMRIGHT", -2, 2)
					offset = offset+25
					
					but:SetScript("OnClick", function(self) 
						self = self.tex
					
						local function ColorCallback(self,r,g,b,a,isAlpha)
							but.tex:SetTexture(r, g, b, a)
							
							if not ColorPickerFrame:IsVisible() then
								--colorpicker is closed, color callback is first, ignore it, alpha callback is the final call after it closes so confirm now
								if isAlpha then
									value = {r, g, b, a}
									if parent then
										SCDB[parent][group][option] = {r, g, b, a}
									else
										SCDB[group][option] = {r, g, b, a}
									end
									but:SetBackdropBorderColor(.1, 1, .1)
								end
							end
						end
						
						HideUIPanel(ColorPickerFrame)
						ColorPickerFrame:SetFrameStrata("FULLSCREEN_DIALOG")
						
						ColorPickerFrame.func = function()
							local r,g,b = ColorPickerFrame:GetColorRGB()
							local a = 1 - OpacitySliderFrame:GetValue()
							ColorCallback(self,r,g,b,a, true)
						end
						
						ColorPickerFrame.hasOpacity = value[4] or false
						ColorPickerFrame.opacityFunc = function()
							local r,g,b = ColorPickerFrame:GetColorRGB()
							local a = 1 - OpacitySliderFrame:GetValue()
							ColorCallback(self,r,g,b,a,true)
						end
						
						local r, g, b, a = value[1], value[2], value[3], value[4]
						ColorPickerFrame.opacity = 1 - (a or 0)
						ColorPickerFrame:SetColorRGB(r, g, b)
						
						ColorPickerFrame.cancelFunc = function()
							ColorCallback(self,r,g,b,a,true)
						end
						ShowUIPanel(ColorPickerFrame)
					end)
				end
			end
		elseif type(value) == "string" and value:find("function") then
			local button = NewButton(option, frame)
			button:SetHeight(20)
			button:SetWidth(90)
			local func = value:gsub("function(.+)", "%1")
			button:SetScript("OnClick", function(self) RunScript(func) end)
			button:SetPoint("TOPLEFT", 15, -(offset))
			offset = offset+25
		end
	end
			
   frame:SetHeight(offset)
	mainframe:Hide()
end


local LaunchMain = function(settings)
	if SCDB["Main"].UIScale == true then
		local tmp = CreateFrame("frame")
		tmp:RegisterEvent("PLAYER_LOGIN")
		tmp:SetScript("OnEvent", function(self, ...)
			local index = GetCurrentResolution()
			local resolution = select(index, GetScreenResolutions())
			SetCVar("useUiScale", 1)
			SetCVar("uiScale", 768/string.match(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)"))
		end)
	end
end

StaticPopupDialogs["INSTALL"] = {
	text = "SuperClassic Install.|nNeed to reload ui for save all settings.|n In future you can change settings in |cffaaaaff\"Settings - Interface - Addons - SuperClassic\"|r by press a key |cffaaffaa\"Save\"|r",
	button1 = ACCEPT,
	button2 = CANCEL,
	OnAccept = function() SCDB.firstStart = false; setupVars(); ReloadUI(); end,
	OnCancel = function() SCDB.firstStart = true end,
	timeout = 0,
	whileDead = 1,
}

StaticPopupDialogs["SAVEOPTS"] = {
	text = "Settings changed.|nReload UI?",
	button1 = ACCEPT,
	button2 = CANCEL,
	OnAccept = function() ReloadUI(); end,
	OnCancel = function() end,
	timeout = 0,
	whileDead = 1,
}

SuperClassic.modules = {}
SuperClassic:RegisterEvent("ADDON_LOADED")
SuperClassic:SetScript("OnEvent", function()
	if not SCDB or SCDB.firstStart then
		 StaticPopup_Show("INSTALL")
	end
	SCDB = SCDB or DefaultSettings
	
	if not SCDB.UISavedPositions then SCDB.UISavedPositions = {} end
	UIMovableFrames = {}

	for k,v in pairs(DefaultSettings) do
		if SCDB[k] == nil then
			SCDB[k] = v
			if type(v) == "table" then
				for n,m in pairs(v) do
					if SCDB[k][n] == nil then
						SCDB[k][n] = m
						print("|cffaaffaaRestored|r "..k.." |cffaaffaaoption."..n.."|r value")
					end
				end
			end
			print("|cffaaffaaRestored|r "..k.." |cffaaffaaoption|r")
		end
	end
 
	InterfaceOptionsFrameOkay:HookScript("OnClick", function() 
		if settingsChanged then
			StaticPopup_Show("SAVEOPTS")
		end
	end)
	
	if not SCDB.modules then SCDB.modules = {} end
	SuperClassic.main = CreateFrame("frame", "|cff00DDAASuperClassic|r", InterfaceOptionsFramePanelContainer)
	SuperClassic.main.name = "|cff00DDAASuperClassic|r"
	InterfaceOptions_AddCategory(SuperClassic.main)
		
	parseOptions(SuperClassic.main, "Main", SCDB["Main"])
	
	LaunchMain(SCDB)
	
	local resetm = NewButton("|cffff0000Reset All|r", SuperClassic.main)
	resetm:SetWidth(90)
	resetm:SetHeight(20)
	resetm:SetPoint("BOTTOMLEFT",10, 10)
	resetm:SetScript("OnClick", function(self) SCDB = nil ReloadUI() end)
	
	local savem = NewButton("Save", SuperClassic.main)
	savem:SetWidth(90)
	savem:SetHeight(20)
	savem:SetPoint("BOTTOMRIGHT", -10, 10)
	savem:SetScript("OnClick", function(self) ReloadUI() end)
		
	table.sort(SuperClassic.modules, function(a,b) return a.name < b.name end)
	for i, module in pairs(SuperClassic.modules) do
		if SCDB.modules[module.name] == nil then SCDB.modules[module.name] = true end
			
		local childpanel = CreateFrame("frame", module.name, InterfaceOptionsFramePanelContainer)
		childpanel.name = module.name
		childpanel.parent = SuperClassic.main.name
		
		local label = NewLabel(module.name, childpanel)
		label:SetPoint("TOP", 0, -10)

		local checkbox = CreateFrame("CheckButton", "cb_module"..module.name, childpanel, "InterfaceOptionsCheckButtonTemplate")
		if SCDB.modules[module.name] then
			_G["cb_module"..module.name.."Text"]:SetText("|cff00ff00Enable|r")
		else
			_G["cb_module"..module.name.."Text"]:SetText("|cffff0000Enable|r")
		end
		checkbox:SetChecked(SCDB.modules[module.name])
		checkbox:SetScript("OnClick", function() 
			SCDB.modules[module.name] = not SCDB.modules[module.name] 
			if SCDB.modules[module.name] then
				_G["cb_module"..module.name.."Text"]:SetText("|cff00ff00Enable|r")
			else
				_G["cb_module"..module.name.."Text"]:SetText("|cffff0000Enable|r")
			end
		end)
		checkbox:SetPoint("TOPLEFT", childpanel, 20, -20)
			
		InterfaceOptions_AddCategory(childpanel)
		
		local reset = NewButton("Reset module options", childpanel)
		reset:SetWidth(140)
		reset:SetHeight(20)
		reset:SetPoint("BOTTOMLEFT",10, 10)
		reset:SetScript("OnClick", function(self) SCDB[module.name] = nil ReloadUI() end)
	
		local save = NewButton("Save", childpanel)
		save:SetWidth(90)
		save:SetHeight(20)
		save:SetPoint("BOTTOMRIGHT", -10, 10)
		save:SetScript("OnClick", function(self) ReloadUI() end)

		module.Init()
		
		parseOptions(childpanel, module.name, SCDB[module.name])
	end
	SuperClassic:UnregisterEvent("VARIABLES_LOADED")
	SuperClassic:SetScript("OnEvent", nil)
	--ChatFrame1:Clear()
	print("|cff00aaddSuperClassic|r loaded. Type |cffff8888/sc|r or |cffff8888/sc help|r for more info, |cffff8888/sc ui|r for show options GUI")
	
	SLASH_SuperClassic1 = "/sc";
	SlashCmdList["SuperClassic"] = function(cmd)
		local cmd, md = cmd:match("^(%S*)%s*(.-)$")
		if (cmd == "" and md == "") then
			print("|cff00aaddSuperClassic|r Options: /sc <option>")
			print("/rl - reload UI")
			print("/sc help or /sc - this help")
			print("/sc ui - show options GUI")
			print("/tcb - castbars settings")
			print("/mf - frames positions settings")
			print("/za - zerg alert module |cffff0000[New!]|r")
			print("/aw - aura watcher |cffff0000[New!]|r")
			print("/rc - ready check")
		elseif (cmd:lower() == "help") then
			if (md:lower() == "aw" or md:lower()=="aurawatch") then
				print("|cff00aaddAuraWatch|r Options: /aw <option>")
				print("/aw : lock/unlock all spell icons")
				print("/aw help : this help")
				print("/aw add <spell ID> : adding a spell to watch")
				print("/aw del <spell ID> : delete watching spell")
				print("/aw list : show list of all spells")
				print("after adding or deleting spells you should to reload UI for save settings")
			else
				print("|cff00aaddSuperClassic|r Options: /sc <option>")
				print("/rl - reload UI")
				print("/sc help or /sc - this help")
				print("/sc ui - show options GUI")
				print("/tcb - castbars settings")
				print("/mf - frames positions settings")
				print("/za - zerg alert module |cffff0000[New!]|r")
				print("/aw - aura watcher |cffff0000[New!]|r")
				print("/rc - ready check")
			end
		elseif cmd:lower() == "ui" then
			InterfaceOptionsFrame_OpenToCategory(SuperClassic.main)
		end
	end
	
end)